/*
 *	ESEMPIO DI SCRITTURA DI UN CLIENT
 *      ECHO CLIENT basato su TCP con le seguenti caratteristiche:
 *      - orientato alla linea
 *      - termina inviando la linea "close" oppure "stop"

 Ho preso spunto dal file Client0.c e l'ho modificato per lo scopo per cui  nato questo progetto e cio automatizzare telnet. La limitazione di questo socket   che  compatibile con server linux e non si la standarizzazione dei comandi che garantisce telnet.
 Per creae l'eseguibile digitare in shell
>	gcc -o nome_file_eseguibile nome_questo_file mybsdfun.c
 questultimo file contiene le librerie standar di bsd.
NOTA: Nella directory deve esserci anche il file mysocket.h , la libreria che contiene le funzioni per il socket.
 Creato l'esequibile per lanciarlo digitare da shell
> nome_file_eseguibile IP_host_remota PORTA_host remota nome_file_comandi modo
 Queste a grandi linee come utilizzarlo, comunque allego un file di testo README

Dichiaro che questa  la versione "1.0"
Copyright Monday 17 Feb 2003, Italy
By Boymix (boymix81@email.it)	
 */

/*Versione 1.1, Modifico modalit di trasmissione, 1 sempre a linea di comando 2 sempre un carattere alla volta e aspetto il riscontro ad uno "\n". */

#include     <stdio.h>
#include     <stdlib.h>
#include     <string.h>
#include     "mysocket.h"

#define BUFLEN	128

/* Prototipi delle funzioni */
int getline(char * line, char *prompt);
int writen(SOCKET, char *, int);
int readline (SOCKET s, char *ptr, int maxlen);

/* Il file va eseguito passando come 1 parametro l'ip 2 la porta 3 parametro il file di comandi 4 parametro modo "1" trasmetto tutto "2" trasmetto un carattere alla volta senza aspettare riscontro fino al"\n.\n" */

main(int argc, char ** argv)
{
	char     	car,buf[BUFLEN];	   /* transmission buffer */
	char	 	rbuf[BUFLEN];	   /* receiver buffer */
	char 		termin[4];	/*carattere termina per email*/
	char		carcor[4];   /*terna corrente*/
	char		codris[4];	/*codice risposta*/
        unsigned long	taddr_n, taddr_h;  /* IP addr. (netwk/host byte order)*/
	unsigned short	tport_n, tport_h;  /* port number */
	struct sockaddr_in	saddr;	   /* server address */
	SOCKET			s;
	int			result,i,len,trasmetti,tp_mail,riscontro;
	FILE 			*filetrasm;
	
   

        /* Inizializzazione interfaccia dei socket */
	SockStartup();

	/* input di indirizzo e porta del server cui collegarsi */
        
        strcpy(buf,argv[1]);  /*passato come parametro*/
	strcat(buf,"\0");
	taddr_n = inet_addr(buf);
	taddr_h = ntohl(taddr_n);

	tport_h = atoi(argv[2]); /*passato come parametro */
	tport_n = htons(tport_h);

	/* creazione del socket */
    	printf("Creating socket\n");
	s = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	if (s == INVALID_SOCKET)
		err_fatal("socket() failed");
	printf("done. Socket number: %d\n",s);

	/* preparazione dell'indirizzo */
	saddr.sin_family      = AF_INET;
	saddr.sin_port        = tport_n;
	saddr.sin_addr.s_addr = taddr_n;

	/* connessione */
	showAddr("Connecting to target address ", &saddr);
	result = connect(s, (struct sockaddr *) &saddr, sizeof(saddr));
	if (result == -1)
		err_fatal("connect() failed");
	printf("done.\n");

	/* ciclo principale */
	printf("Use message 'close' to close connection.\n");
	printf("Use message 'stop' to shut down server.\n");
	
        /*inizializzazione per mail*/
	strcpy(termin,"\n.\n\0");
	carcor[3]='\0';
	tp_mail=0;

	if((filetrasm=fopen(argv[3],"r"))==NULL)  /* nome file come parametro */
		{printf("Errore apetura file\n");
		 exit(1);}

	len=0;	
	for(car=fgetc(filetrasm);car!=EOF;car=fgetc(filetrasm))
         {  buf[len]=car;
            len++; 
	    switch(atoi(argv[4]))
		{case 1: {if(car=='\n') /*caso modalit testuale*/
		             {riscontro=1;
		              trasmetti=1;}	
		          else
		             {riscontro=0;		
		              trasmetti=0;}
			  break;
			  }
		 case 2: {trasmetti=1; /*caso modalit carattere */
                          if(car=='\n')                                       
                             riscontro=1;  /*se  finito il comando aspetta un riscontro */
                         else
                             riscontro=0;
			 break;
			 }
		 default: {printf("\nNon  stato inserito un modo corretto, inserire o 1 'command mode' o 2 'charatter mode' al prossimo avvio del programma");
			   exit(1);
			   break;
			}	 	 
		}   
         if(tp_mail==1)
	       {carcor[0]=carcor[1];
                carcor[1]=carcor[2];
                carcor[2]=car;
  		trasmetti=1;
                if((strcmp(carcor,termin))==0)
		        {tp_mail=0;     
/*devo trasmettere i caratteri uno alla volta e alla fine del messaggio aspettare il riscontro */
			 riscontro=1;}
	        else
			 riscontro=0;
	       }  
            if(trasmetti==1)
              {buf[len]='\0';	
            
                if(writen(s, buf, len) != len)
	        {
		printf("Write error\n");
		break;
	        } 
	    if(riscontro==0)
		result=1;	/*devo trasmettere un carattere senza riscontro  metto io il riscontro */
	    else				
	          {printf("waiting for response...\n");
	           result = readline(s, rbuf, BUFLEN);}
	    if (result <= 0)
	    {
		printf("Read error/Connection closed\n");
		closesocket(s);
		SockCleanup();
		exit(1);
	    }
	    else
	    {   rbuf[result-2]='\0';
		if(riscontro!=0)
                        {printf("Received response \n>>%s<<\n", rbuf);
			 printf("==============================================\n");			}
		for(i=0;i<3;i++)	
			codris[i]=rbuf[i];
		codris[i]='\0';
		if(atoi(codris)==354)	/*controllo codice di ritorno*/
			{tp_mail=1;}	/*caso email seganle data*/
	    }

	    if (!strcmp(buf, "close\n") || !strcmp(buf, "stop\n")) break;
	  len=0;
	   }
	  }		  
        
	fclose(filetrasm);
        closesocket(s);
	SockCleanup();
	exit(0);
}

/* Funzione per l'input di una linea di testo con stringa di invito */
int getline(char *line, char *prompt)
{
        char	ch;

	printf("%s", prompt);
	while ((ch = getchar()) != '\n' && ch != EOF)
		*line++ = ch;
	*line = '\0';
	if (ch == EOF)
		return(EOF);
	else    return(1);
}

/* Read a line from stream socket s to buffer ptr 
   store it (including newline) in buffer ptr
   whose length is maxlen */
int readline (SOCKET s, char *ptr, int maxlen)
{
    int n, nread;
    char c;

    for (n=1; n<maxlen; n++)
    {
	nread=recv(s, &c, 1, 0);
	if (nread == 1)
	{
	    *ptr++ = c;
	    if (c == '\n') break;
	}
	else if (nread == 0)	/* connection closed by party */
	{
	    if (n == 1)
		return (0);
	    else 
	    	break;
	}
	else 			/* error */
	    return (-1);
    }
    *ptr = 0;
    return (n);
}

/* Write nbytes from buffer ptr to stream socket s */
int writen(SOCKET s, char *ptr, int nbytes)
{
    int nleft, nwritten;

    for (nleft=nbytes; nleft > 0; )
    {
	nwritten = send(s, ptr, nleft, 0);
	if (nwritten <=0)
	    return (nwritten);
	else
	{
	    nleft -= nwritten;
	    ptr += nwritten;   
	}
    }
    return (nbytes - nleft);
}
